- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Protected Member Functions | Protected Attributes | Friends

# FbxDeformer Class Reference

This reference page is linked to from the following overview topics: Supported Scene Elements, List of Python Fbx classes.

Search for all occurrences

## Detailed Description

Base class for skin deformer (FbxSkin) and vertex cache deformer (FbxVertexCacheDeformer).

The corresponding deformer types are FbxDeformer::eSkin and FbxDeformer::eVertexCache. A deformer can be binded to a geometry (FbxGeometry) to act on its shape. Typically, some objects under the deformer are animated, and via the deformer, the geometry is animated too.

A skin deformer contains clusters (FbxCluster). Each cluster acts on a subset of the geometry's control points, with different weights. For example, a mesh of humanoid shape can have a skin attached, that describes the way the humanoid mesh is deformed by bones. When the bones are animated, the clusters act on the geometry to animate it too.

A vertex cache deformer contains a cache (FbxCache). The cache contains animation information for every control point of the geometry.

Definition at line 47 of file fbxdeformer.h.

`#include <fbxdeformer.h>`

Inheritance diagram for FbxDeformer:
[legend]

List of all members.

## Protected Member Functions
| FbxDeformer (FbxManager &pManager, char const *pName)
virtual FbxStringList | GetTypeFlags () const
## Protected Attributes
FbxError | mError
bool | mMultiLayer
## Friends
class | FbxGeometry
class | FbxScene
## Multi-Layer Flag
This flag is available for backward compatibility with older version of FBX files and should not be used anymore.All the animation layering system has been moved to the FbxAnimLayer and FbxAnimStack classes.
void | SetMultiLayer (bool pMultiLayer)
| Set multi-layer state flag.
bool | GetMultiLayer () const
| Get multi-layer state.
## Deformer types
enum | EDeformerType { eUnknown, eSkin, eBlendShape, eVertexCache }
| Deformer types. More...
virtual EDeformerType | GetDeformerType () const
| Get the deformer type.
## Error Management
enum | EErrorCode { eError, eErrorCount }
| Error identifiers. More...
FbxError & | GetError ()
| Retrieve error object.
EErrorCode | GetLastErrorID () const
| Get last error code.
const char * | GetLastErrorString () const
| Get last error string.

## Member Enumeration Documentation

enum EDeformerType

Search for all occurrences

Deformer types.

Enumerator:

  eUnknown | Unknown deformer type. Search for all occurrences
  eSkin | Type FbxSkin. Search for all occurrences
  eBlendShape | Type FbxBlendShape. Search for all occurrences
  eVertexCache | Type FbxVertexCacheDeformer. Search for all occurrences

Definition at line 76 of file fbxdeformer.h.

            {
                eUnknown,
                eSkin,
                eBlendShape,
                eVertexCache
            };

enum EErrorCode

Search for all occurrences

Error identifiers.

Enumerator:

  eError | An error occurred. Search for all occurrences
  eErrorCount | Number of error identifiers. Search for all occurrences

Definition at line 102 of file fbxdeformer.h.

            {
                eError,
                eErrorCount
            };

## Constructor & Destructor Documentation

FbxDeformer | ( | FbxManager & | pManager,
|  | char const * | pName
| ) |  | `[protected]`

## Member Function Documentation

void SetMultiLayer | ( | bool | pMultiLayer | ) |

Search for all occurrences

Set multi-layer state flag.

Parameters:

  pMultiLayer | Set to `true` to enable multi-layering.

bool GetMultiLayer | ( |  | ) | const

Search for all occurrences

Get multi-layer state.

Returns:
  The current state of the multi-layer flag.

virtual EDeformerType GetDeformerType | ( |  | ) | const `[inline, virtual]`

Search for all occurrences

Get the deformer type.

Returns:
  Deformer type identifier. Default value is eUnknown.

Reimplemented in FbxBlendShape, FbxSkin, and FbxVertexCacheDeformer.

Definition at line 87 of file fbxdeformer.h.

    { return eUnknown; }

FbxError& GetError | ( |  | ) |

Search for all occurrences

Retrieve error object.

Returns:
  Reference to error object.

EErrorCode GetLastErrorID | ( |  | ) | const

Search for all occurrences

Get last error code.

Returns:
  Last error code.

const char* GetLastErrorString | ( |  | ) | const

Search for all occurrences

Get last error string.

Returns:
  Textual description of the last error.

virtual FbxStringList GetTypeFlags | ( |  | ) | const `[inline, protected, virtual]`

Search for all occurrences

Reimplemented from FbxObject.

Reimplemented in FbxBlendShape, FbxSkin, and FbxVertexCacheDeformer.

Definition at line 133 of file fbxdeformer.h.

    { return FbxStringList(); }

## Friends And Related Function Documentation

friend class FbxGeometry `[friend]`

Search for all occurrences

Definition at line 139 of file fbxdeformer.h.

friend class FbxScene `[friend]`

Search for all occurrences

Reimplemented from FbxObject.

Reimplemented in FbxBlendShape, and FbxSkin.

Definition at line 140 of file fbxdeformer.h.

## Member Data Documentation

FbxError mError `[protected]`

Search for all occurrences

Definition at line 136 of file fbxdeformer.h.

bool mMultiLayer `[protected]`

Search for all occurrences

Definition at line 137 of file fbxdeformer.h.

The documentation for this class was generated from the following file:

- fbxsdk/scene/geometry/fbxdeformer.h

FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer
FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer FbxDeformer